deferred class CHAIN_EXAMPLE [G]

inherit
	SPECIFICATION_CHAIN [G]
		rename
			cursor as implementation_cursor,
			cursor_model as cursor,
			sequence_model as sequence,
			bag_model as bag,
			indexable_model as indexable
		end

	SPECIFICATION_UNBOUNDED [G]

feature -- Element change

	merge_left (other: like Current) is
			-- Merge `other' into current structure before cursor
			-- position. Do not move cursor. Empty `other'.
		require
			extendible
			cursor >= sequence.lower_bound
			other /= Void
			not is_equal (other)
		deferred
		ensure
			(old cursor.is_equal (sequence.lower_bound)) implies sequence.is_equal (old other.sequence.concatenated (sequence))
			(old cursor > sequence.upper_bound) implies sequence.is_equal (old sequence.concatenated (other.sequence))
			(old cursor > sequence.lower_bound and cursor <= sequence.upper_bound) implies sequence.is_equal (old sequence.interval (sequence.lower_bound, cursor - 1).concatenated (other.sequence).concatenated (sequence.interval (cursor, sequence.upper_bound)))
			cursor.is_equal (old cursor + 1)
			bag.is_equal (old bag.added (other.bag))
			indexable.cardinality.is_equal (old indexable.cardinality + other.indexable.cardinality)
			other.sequence.is_empty and other.bag.is_empty and other.indexable.is_empty
		end

end -- class CHAIN_EXAMPLE