deferred class DYNAMIC_CHAIN_EXAMPLE [G]

inherit
	SPECIFICATION_CHAIN [G]
		rename
			cursor as implementation_cursor,
			cursor_model as cursor,
			sequence_model as sequence,
			bag_model as bag,
			indexable_model as indexable
		end

	SPECIFICATION_UNBOUNDED [G]

feature -- Element change

	put_front (other: like item) is
			-- Add `other' at beginning.
			-- Do not move cursor.
		require
			other /= Void
		deferred
		ensure
			sequence.is_equal (old sequence.prepended (other))
			(old cursor >= sequence.lower_bound) implies cursor.is_equal (old cursor + 1)
			sequence.first.is_equal (other)
			(old cursor < sequence.lower_bound) implies cursor.is_equal (old cursor)
			other.is_equal (old other)
			bag.is_equal (old bag.extended (other))
			indexable.cardinality.is_equal (old indexable.cardinality + 1)
			(old not sequence.is_defined (cursor)) implies not sequence.is_defined (cursor)
		end

end -- class DYNAMIC_CHAIN_EXAMPLE