indexing
	description: "Mathematical objects that contain elements which can be filtered by a predicate"

deferred class
	MML_FILTERABLE[G]

inherit
	MML_ANY
		undefine
			equals, is_equal, untyped,
			is_pair_valued, is_set_valued,
			is_relation_valued, is_function_valued,
			is_graph_valued, is_sequence_valued
		end

feature -- Filtering

	filtered (predicate: FUNCTION [ANY, TUPLE [G], BOOLEAN]) : like Current is
			-- The object containing all elements in `current' not filtered by `predicate'.
		require
			predicate_not_void : predicate /= Void
		deferred
		end

end -- class MML_FILTERABLE