indexing
	description: "Mathematical objects that contain elements over which an operation can be performed"

deferred class
	MML_PROCESSABLE [G]

inherit
	MML_ANY
		undefine
			equals, is_equal, untyped,
			is_pair_valued, is_set_valued,
			is_relation_valued, is_function_valued,
			is_graph_valued, is_sequence_valued
		end

feature -- Processing

	applied (action: PROCEDURE [ANY, TUPLE [G]]) : like Current is
			-- The object with `action' applied to every element of `current'.
		require
			action_not_void : action /= Void
		deferred
		end

feature {MML_ANY} -- Implementation

	do_all (action: PROCEDURE [ANY, TUPLE [G]]) is
			-- Apply `action' to every element of `current'.
			-- CAUTION: This feature is not pure
		require
			action_not_void : action /= Void
		deferred
		end

	do_if (action: PROCEDURE [ANY, TUPLE [G]]; predicate: FUNCTION [ANY, TUPLE [G], BOOLEAN]) is
			-- Apply `action' to every element of `current' that satisfies `predicate'.
			-- CAUTION: This feature is not pure
		require
			action_not_void : action /= Void
			predicate_not_void : predicate /= Void
		deferred
		end

end -- class MML_PROCESSABLE