indexing
	description: "Mathematical objects over which existential and universal quantifiers are defined"

deferred class
	MML_QUANTIFIABLE[G]

inherit
	MML_ANY
		undefine
			equals, untyped,
			is_pair_valued, is_set_valued,
			is_relation_valued, is_function_valued,
			is_graph_valued, is_sequence_valued
		end

	MML_FUNCTIONALS[G]
		export
			{MML_ANY}
				all
		end

feature -- Quantifiers

	there_exists (predicate: FUNCTION [ANY, TUPLE [G], BOOLEAN]) : BOOLEAN is
			-- Does `current' contain an element which satisfies `predicate'?
		require
			predicate_not_void : predicate /= Void
		deferred
		ensure
			definition_of_there_exists : Result.is_equal (not for_all (agent negated (?, predicate)))
		end

	for_all (predicate: FUNCTION [ANY, TUPLE [G], BOOLEAN]) : BOOLEAN is
			-- Does `current' contain only elements which satisfy `predicate'?
		require
			predicate_not_void : predicate /= Void
		deferred
		ensure
			definition_of_for_all : Result.is_equal (not there_exists (agent negated (?, predicate)))
		end

end -- class MML_QUANTIFIABLE