indexing
	description: "Mathematical objects over which a result can be computed using an accumulator function"

deferred class
	MML_REDUCEABLE [G, H]

inherit
	MML_ANY
		undefine
			equals, is_equal, untyped,
			is_pair_valued, is_set_valued,
			is_relation_valued, is_function_valued,
			is_graph_valued, is_sequence_valued
		end

feature -- Accumulation

	reduced (start : G; operator : FUNCTION [ANY, TUPLE [G, G], G]; mapping: FUNCTION [ANY, TUPLE [H], G]) : G is
			-- The value accumulated over `current' starting from `start' using `mapping' and `operator'.
		require
			start_not_void : start /= Void
			operator_not_void : operator /= Void
			mapping_non_void : mapping /= Void
		deferred
		end

end -- class MML_REDUCEABLE