deferred class SPECIFICATION_BILINEAR [G]

inherit
	SPECIFICATION_LINEAR [G]
		rename
			search as sequential_search
		export
			{NONE}
				sequential_search
		end

	SPECIFICATION_LINEAR [G]
		select
			search
		end

feature -- Access

	off: BOOLEAN is
			-- Is there no current item?
		deferred
		ensure then
			definition_of_off: (is_empty or before or after) implies Result
		end

feature -- Cursor movement

	before: BOOLEAN is
			-- Is there no valid position to the left of current one?
		deferred
		ensure
			empty_implies_not_result: is_empty implies not Result
			pure_feature: is_equal (old Current)
			result_implies_off: Result implies off
		end

	back is
			-- Move to previous position.
		require
			not_before: not before
		deferred
		ensure
			not_outside_implies_moved: not (old off) and not (old before) implies index.is_equal (old index - 1)
			off_implies_exhausted: off implies exhausted
		end

invariant
	empty_implies_after: is_empty implies (after and not before)
	not_after_and_before: not (after and before)
	before_implies_off: before implies off

end -- class SPECIFICATION_BILINEAR