deferred class SPECIFICATION_BOUNDED[G]

inherit
	SPECIFICATION_FINITE [G]

feature -- Measurement

	capacity: INTEGER is
			-- Number of items that may be stored
		deferred
		ensure
			pure_feature: is_equal (old Current)
			non_negative_result: Result >= 0
		end

feature -- Status report

	full: BOOLEAN is
			-- Is structure full?
		deferred
		ensure then
			definition_of_full: Result.is_equal (count.is_equal (capacity))
		end

	resizable: BOOLEAN is
			-- May `capacity' be changed?
		deferred
		end

invariant
	count_less_capacity : count <= capacity
	definition_of_full : full.is_equal (count.is_equal (capacity))
	non_negative_capacity : capacity >= 0

end -- class SPECIFICATION_BOUNDED