deferred class SPECIFICATION_CURSOR_STRUCTURE [G]

inherit
	SPECIFICATION_ACTIVE [G]

feature -- Access

	cursor: SPECIFICATION_CURSOR is
			-- Current cursor position
		deferred
		ensure
			pure_function: is_equal (old Current)
			immutable_model: bag_model.is_equal (old bag_model)
			result_not_void: Result /= Void
		end

feature -- Status report

	valid_cursor (other: SPECIFICATION_CURSOR): BOOLEAN is
			-- Can the cursor be moved to position `other'?
		require
			other_not_void: other /= Void
		deferred
		ensure then
			pure_feature: is_equal (old Current)
			immutable_argument: other.is_equal (old other)
			immutable_argument: bag_model.is_equal (old bag_model)
		end

feature -- Cursor movement

	go_to (other: SPECIFICATION_CURSOR) is
			-- Move cursor to position `other'.
		require
			other_not_void: other /= Void
			need_valid_cursor: valid_cursor (other)
		deferred
		ensure
			new_cursor_position: cursor.is_equal (other)
			immutable_model: bag_model.is_equal (old bag_model)
		end

invariant
	cursor_not_void: cursor /= Void

end -- class SPECIFICATION_CURSOR_STRUCTURE