deferred class SPECIFICATION_INDEXABLE [G, H -> INTEGER]

inherit
	SPECIFICATION_TABLE [G, H]
		rename
			valid_key as valid_index,
			table_model as indexable_model
		end

	MML_FUNCTIONALS [H]
		export
			{NONE}
				all
		end

feature -- Measurement

	index_set: SPECIFICATION_INTEGER_INTERVAL is
			-- Range of acceptable indexes
		deferred
		ensure
			definition_of_index_set: Result.for_all (agent valid_index (?))
			pure_feature: is_equal (old Current)
			immutable_models: indexable_model.is_equal (old indexable_model) and bag_model.is_equal (old bag_model)
			result_not_void: Result /= Void
		end

feature -- Status report

	valid_index (number: H): BOOLEAN is
			-- Is `number' a valid index?
		deferred
		ensure then
			definition_of_valid_index: Result.is_equal (indexable_model.domain.is_member (number))
			result_implies_within_interval: Result implies (number >= index_set.lower and number <= index_set.upper)
		end

invariant
	index_set_not_void: index_set /= Void

	definition_of_valid_index: index_set.for_all (agent valid_index (?))
	definition_of_index_set: indexable_model.domain.untyped.for_all (agent index_set.has (?))

end -- class SPECIFICATION_INDEXABLE