deferred class SPECIFICATION_LIST [G]

inherit
	SPECIFICATION_CHAIN [G]
		export
			{ANY} remove
		end

feature -- Status report

	after: BOOLEAN is
			-- Is there no valid cursor position to the right of cursor?
		deferred
		ensure then
			definition_of_after: Result.is_equal (index.is_equal (sequence_model.upper_bound + 1))
		end

	before: BOOLEAN is
			-- Is there no valid cursor position to the left of cursor?
		deferred
		ensure then
			definition_of_before: Result.is_equal (index.is_equal (sequence_model.lower_bound - 1))
		end

feature -- Cursor movement

	forth is
			-- Move to next position; if no next position,
			-- ensure that `exhausted' will be true.
		deferred
		ensure then
			definition_of_forth: index.is_equal (old index + 1)
		end

invariant
	definition_of_before: before.is_equal (index.is_equal (sequence_model.lower_bound - 1))
	definition_of_after: after.is_equal (index.is_equal (sequence_model.upper_bound + 1))

end -- class SPECIFICATION_LIST