deferred class
	SPECIFICATION_RESIZABLE[G]

inherit
	SPECIFICATION_BOUNDED [G]

feature -- Measurement

	growth_percentage: INTEGER is 50
			-- Percentage by which structure will grow automatically

	minimal_increase: INTEGER is 5
			-- Minimal number of additional items

	additional_space: INTEGER is
			-- Proposed number of additional items.
		deferred
		ensure
			pure_feature: is_equal (old Current)
			positive_additional_space : Result > 0
		end

feature -- Resizing

	automatic_grow is
			-- Change the capacity to accommodate at least
			-- `Growth_percentage' more items.
		deferred
		ensure
			definition_of_automatic_grow: capacity >= old capacity + old capacity * growth_percentage // 100
		end

	grow (i: INTEGER) is
			-- Ensure that capacity is at least `i'.
		require
			non_negative_i: i >= 0
		deferred
		ensure
			definition_of_grow: capacity >= i
			immutable_argument: i.is_equal (old i)
		end

invariant
	definition_of_growth_percentage : growth_percentage >= 1 and growth_percentage <= 100

	positive_minimal_increase: minimal_increase > 0
	positive_additional_space: additional_space > 0

end -- class SPECIFICATION_RESIZABLE