deferred class SPECIFICATION_DYNAMIC_LIST [G]

inherit
	SPECIFICATION_LIST [G]
		rename
			cursor as list_cursor,
			sequence_model as sequence,
			indexable_model as indexable,
			cursor_model as cursor
		end

	SPECIFICATION_DYNAMIC_CHAIN [G]
		rename
			wipe_out as chain_wipe_out,
			cursor as list_cursor,
			sequence_model as sequence,
			indexable_model as indexable,
			cursor_model as cursor
		export
			{NONE} chain_wipe_out
		end

	SPECIFICATION_DYNAMIC_CHAIN [G]
		rename
			cursor as list_cursor,
			sequence_model as sequence,
			indexable_model as indexable,
			cursor_model as cursor
		select
			wipe_out
		end

feature -- Removal

	remove is
			-- Remove current item.
		require else
			prunable
			writable
			sequence.is_defined (cursor)
		deferred
		ensure then
			sequence.is_equal (old sequence.pruned_at (cursor))
			sequence.is_empty implies cursor.is_equal (sequence.upper_bound + 1)
			indexable.cardinality.is_equal (old indexable.cardinality - 1)
			cursor.is_equal (old cursor)
		end

	wipe_out is
			-- Remove all items.
		deferred
		ensure then
			cursor.is_equal (sequence.lower_bound - 1)
		end

end -- class SPECIFICATION_DYNAMIC_LIST